<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnstructuredFareCalc StructType
 * @package Dg
 * @subpackage Structs
 */
class DgUnstructuredFareCalc extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The FareCalcMode
     * @var string
     */
    public $FareCalcMode;
    /**
     * Constructor method for UnstructuredFareCalc
     * @uses DgUnstructuredFareCalc::set_()
     * @uses DgUnstructuredFareCalc::setFareCalcMode()
     * @param string $_
     * @param string $fareCalcMode
     */
    public function __construct($_ = null, $fareCalcMode = null)
    {
        $this
            ->set_($_)
            ->setFareCalcMode($fareCalcMode);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \dgsoft\StructType\DgUnstructuredFareCalc
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get FareCalcMode value
     * @return string|null
     */
    public function getFareCalcMode()
    {
        return $this->FareCalcMode;
    }
    /**
     * Set FareCalcMode value
     * @param string $fareCalcMode
     * @return \dgsoft\StructType\DgUnstructuredFareCalc
     */
    public function setFareCalcMode($fareCalcMode = null)
    {
        // validation for constraint: string
        if (!is_null($fareCalcMode) && !is_string($fareCalcMode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fareCalcMode)), __LINE__);
        }
        $this->FareCalcMode = $fareCalcMode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgUnstructuredFareCalc
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
